clear all
close all
clc

I = double(imread('../img/barbara_awgn_noise.png'));
[h,w,z] = size(I);

figure, 
imagesc(I)
 
%Paramètres (à faire varier)
v_nei = 4;  s_s = 1; s_c = 4;
 
img_bf = double(I*0);
%Parcours de tous les pixels de l'image
for i=1:h
    i
    for j=1:w
        sum_w = 0;
         %Sélection d'une fenêtre (2*v_nei+1)x(2*v_nei+1) ajustée au bord
         for ii=max(i-v_nei,1):min(i+v_nei,h)
             for jj=max(j-v_nei,1):min(j+v_nei,w)
                  %A compléter
                  w_s = exp(-sqrt((i-ii)^2+(j-jj)^2)/(2*s_s^2)); %Poids spatial
                  w_c = exp(-sqrt(sum((I(i,j,:)-I(ii,jj,:))).^2)/(2*s_c^2)); %Poids couleur
                  weight = w_c*w_s;
                  %Si weight = 1 -> filtre moyenneur
                  img_bf(i,j,1) = img_bf(i,j,1) + weight*I(ii,jj,:);
                  sum_w = sum_w + weight;
             end
         end
       %Normalisation
       img_bf(i,j,:) = img_bf(i,j,:)/sum_w;
    end
end 
%%
figure, 
imagesc(uint8(img_bf))
colormap(gray)


%%

figure, 
a(1) = subplot(121);
imagesc(I); colormap(gray);
a(2) = subplot(122);
imagesc(img_bf);
linkaxes(a);
