import numpy as np
import matplotlib.pyplot as plt
import scipy.io as sio


#%%%%%%%%%%% Format numérique %%%%%%%%%%%%%%%%%
s = sio.loadmat('../../img/challenge.mat')
for key, value in s.items():
    print(key)
    


#%%
I = s.get('A')  #Mandrill
I = I.astype('double')

plt.figure(1)
plt.imshow(I)
plt.show()

# RGB uint8 veut du [0,255], RGB double veut du [0,1]
# donc soit on repasse en uint8, soit on normalise pour être entre [0,1] 
plt.figure(2)
plt.imshow(I.astype('uint8'))
plt.show()

plt.figure(3)
plt.imshow(I/255)
plt.show()


#%% %%%%%%%%%%% Ratio Largeur/Hauteur %%%%%%%%%%%%%%%%%
I = s.get('B') #Formula
plt.figure(1)
plt.imshow(I)
#plt.axis('off') #to remove axis
plt.show()


#%% %%%%%%%%%%% Intervalles d'intensité %%%%%%%%%%%%%%%%%
I = s.get('C') #Radio

fig, ax = plt.subplots()
im = ax.imshow(I)
fig.colorbar(im)

fig, ax = plt.subplots()
im = ax.imshow(I, cmap='gray')
fig.colorbar(im)

fig, axs = plt.subplots()
pc = axs.pcolormesh(I, vmin=100, vmax=130, cmap='gray')
fig.colorbar(pc, ax=axs)
plt.show()


#%% %%%%%%%%%%% Palette continue %%%%%%%%%%%%%%%%%
I = s.get('D') #Chess

plt.figure()
plt.imshow(I, cmap='hsv')
plt.title('hsv')

plt.figure()
plt.imshow(I, cmap='jet')
plt.title('jet')




#%% %%%%%%%%%%% Format numérique %%%%%%%%%%%%%%%%%
I = s.get('E') #World map

fig, ax = plt.subplots()
plt.imshow(I)

from matplotlib import cm
from matplotlib.colors import ListedColormap, LinearSegmentedColormap

jet = cm.get_cmap('jet', 256)
print(jet(0.56))
print(jet(255))
print(jet(0))

new_map = [[0,0,0,1],[1,0,0,1],[0,1,0,1],[0,0,1,1],[1,0,1,1],[1,1,0,1],[0,1,1,1],[1,1,1,1]]
newcmp = ListedColormap(new_map)
p = plt.imshow(I, cmap=newcmp)
fig.colorbar(p)







