import numpy as np
import matplotlib.pyplot as plt

A = plt.imread('../../img/cameraman.tif')
A = plt.imread('../../img/face.png')

if A.ndim == 2:
    h, w = A.shape
else:
    h, w, c = A.shape
plt.figure(1)
plt.imshow(A)
plt.show()

xy = np.floor(plt.ginput(2)).astype('int'); #Tableau Nx2 [x,y] #Arrondi inférieur
x1 = xy[0][0]
x2 = xy[1][0]
y1 = xy[0][1]
y2 = xy[1][1]

if (abs(x2-x1)>abs(y2-y1)):
    profil = A[y1, min(x1,x2):max(x1,x2), :] #Prends les coordonnées sur tous les canaux
    y2 = y1
else:
    profil = A[min(y1,y2):max(y1,y2), x1, :]
    x2 = x1

plt.plot([x1, x2], [y1, y2], color="white", linewidth = 2) #%Affiche un segment sur l'image


plt.figure()
if (c == 1): #Image intensité h*w
    plt.plot(profil)
else: #% c == 3, Image RGB h*w*c
    plt.plot(profil[:, 0], color='r')
    plt.plot(profil[:, 1], color='g')
    plt.plot(profil[:, 2], color='b')

plt.xlabel('Segment');
plt.ylabel('Intensité');
