
clear all
close all
clc

img = imread('../img/pool.tif');
[h,w,c] = size(img);
figure, imagesc(img), 
title('Initial pool.tif');

ycbcr = rgb2ycbcr(img);
cb = ycbcr(:,:,2);
cr = ycbcr(:,:,3);

r = 4; 
cb_r = imresize(imresize(cb,1/r),[h w]); %On perd la dimension originale avec l'arrondi
cr_r = imresize(imresize(cr,1/r),[h w]);
ycbcr(:,:,2) = cb_r;
ycbcr(:,:,3) = cr_r;
img_r = ycbcr2rgb(ycbcr);

figure, 
ll(1) = subplot(121);
imagesc(img_r), 
title(sprintf('Compressed CbCr pool.tif - ratio %1.3f',r));

size_cbcr_comp = h*w+2*h*w/r^2

%% Comparaison avec une compression en RGB %%

%ratio correspondant pour avoir la même taille
%avec une compression des trois canaux RGB
r_rgb = sqrt(3*r^2 / (r^2+2));

img_rr = imresize(img, 1/r_rgb);
img_r_final = imresize(img_rr,[h w]);
ll(2) = subplot(122);
imagesc(img_r_final);
title('Compression RGB');
linkaxes(ll);

[h_r, w_r, z_r] = size(img_rr);
size_rgb_comp = h_r*w_r*z_r

