import numpy as np
import matplotlib.pyplot as plt
import skimage

img = plt.imread('../../img/pool.tif')
if img.ndim == 2:
    h, w, c = img.shape, 1
else:
    h, w, c = img.shape

plt.figure(1)
plt.imshow(img)
plt.show()
plt.title('Initial pool.tif')

#%% conversion ycbcr
ycbcr = skimage.color.rgb2ycbcr(img)
cb = ycbcr[:,:,1]
cr = ycbcr[:,:,2]

#%% resize
r = 10
cb_r = skimage.transform.resize(skimage.transform.resize(cb, [h/r, w/r]), [h, w]) #%On perd la dimension originale avec l'arrondi
cr_r = skimage.transform.resize(skimage.transform.resize(cr, [h/r, w/r]), [h, w])
ycbcr[:,:,1] = cb_r
ycbcr[:,:,2] = cr_r
img_r = skimage.color.ycbcr2rgb(ycbcr)

plt.figure()
plt.subplot(121)
plt.imshow(img_r),
plt.title('Compressed CbCr pool.tif - ratio {}'.format(r))

size_cbcr_comp = h*w+2*h*w/r**2
print(size_cbcr_comp)

#%% Comparaison avec une compression en RGB %%

#ratio correspondant pour avoir la même taille
#avec une compression des trois canaux RGB
r_rgb = np.sqrt(3*r**2 / (r**2+2))
print(r_rgb)

img_rr = skimage.transform.resize(img, [h/r_rgb, w/r_rgb])
img_r_final = skimage.transform.resize(img_rr,[h, w])
plt.subplot(122)
plt.imshow(img_r_final)
plt.title('Compression RGB')

h_r, w_r = img_rr.shape[0], img_rr.shape[1]
size_rgb_comp = h_r*w_r*c
print(size_rgb_comp)
