clear; close all; clc

img = imread('peppers.png');
img = imread('../img/campagne.jpg');

%Conversion niveaux de gris
img_g = rgb2gray(img);

%Boost de la saturation (optionnel)
img_hsv = rgb2hsv(img);
img_hsv(:,:,2) = img_hsv(:,:,2)*2;
img_hsv(img_hsv > 1) = 1; %Seuillage des valeurs limites
img = uint8(hsv2rgb(img_hsv)*255);

%YCbCr - Inversion de l'intensité des canaux de chrominances
img_y = rgb2ycbcr(img);
img_y(:,:,2:3) = 255 - img_y(:,:,2:3);
img_t = ycbcr2rgb(img_y);

%Cercles noir et blanc
[h,w] = size(img_g);
[X,Y] = meshgrid(1:w, 1:h);
C = (X-w/2).^2 + (Y-h/2).^2 < (h/30)^2;
C2 = (X-w/2).^2 + (Y-h/2).^2 < (h/30+3)^2;
img_t(repmat(C2,[1 1 3])) = 255;
img_t(repmat(C,[1 1 3])) = 0;
img_g(C2) = 255;
img_g(C) = 0;

f = figure;
f.Position = [100 100 w*2 h*2];
imagesc(img_t);
pause(10);
imagesc(img_g);
colormap(gray)

%%
v = VideoWriter('illusion.avi'); %,'Uncompressed AVI');
v.FrameRate = 1;
open(v)
for i=1:12
   writeVideo(v, img_t); 
end
for i=1:12
   writeVideo(v, img_g); 
end
close(v)

