import numpy as np
import matplotlib.pyplot as plt
import skimage
import time

img = plt.imread('../../img/campagne.jpg')
h, w, c = img.shape
    
#Conversion niveaux de gris
img_g = np.mean(img.astype('float'), axis=2)

#%%

#Boost de la saturation (optionnel)
img_hsv = skimage.color.rgb2hsv(img)
img_hsv[:,:,1] = img_hsv[:,:,1]*2
img_hsv[img_hsv > 1] = 1 #Seuillage des valeurs limites
img = (skimage.color.hsv2rgb(img_hsv)*255).astype('uint8')

#%%
#YCbCr - Inversion de l'intensité des canaux de chrominances
img_y = skimage.color.rgb2ycbcr(img)
img_y[:,:,1:3] = 255 - img_y[:,:,1:3]
img_t = skimage.color.ycbcr2rgb(img_y)

#Cercles noir et blanc
X, Y = np.meshgrid(range(0,w), range(0,h))
C = ((X-w/2)**2 + (Y-h/2)**2) < (h/30)**2
C2 = ((X-w/2)**2 + (Y-h/2)**2) < (h/30+3)**2
img_t[np.tile(C2[:,:,np.newaxis], [1,1,3])] = 255
img_t[np.tile(C[:,:,np.newaxis], [1,1,3])] = 0
img_g[C2] = 255
img_g[C] = 0

plt.figure(figsize=(12,16))
plt.imshow(img_t, cmap='gray')
plt.show()
plt.pause(10)
plt.imshow(img_g, cmap='gray')
