
clear; close all; clc

img = imread('../img/barbara.bmp');

figure,
subplot 221
imagesc(img);
colormap(gray)

figure(2);
subplot 221
imagesc(log10(abs(fftshift(fft2(img))))) 


%%Réduction de dimension
%% Sous-échantillonnage

Is = img(1:4:end, 1:4:end, :); 
figure(1); subplot 222; imagesc(Is); title('Sous-éch manuel')

Is_imresize = imresize(img, 0.25);
figure(1); subplot 223; imagesc(Is_imresize); title('imresize')


%% Filtrage passe-base a priori

img_passe_bas = conv2(img, fspecial('gaussian', [5 5], 1), 'same'); %On filtre l'image avant de sous-échantillonner (c'est ce que fait imresize)

figure, imagesc(img_passe_bas); colormap(gray); title('Image filtrée par un filtre passe bas');

Is_imresize_maison = img_passe_bas(1:4:end, 1:4:end, :);
figure(1); subplot 224; imagesc(Is_imresize_maison); title('imresize maison')



%% Transformées de Fourier

figure(2);
subplot 222; imagesc(log10(abs(fftshift(fft2(Is))))); title('Sous-éch manuel')
subplot 223; imagesc(log10(abs(fftshift(fft2(Is_imresize))))); title('imresize')
subplot 224; imagesc(log10(abs(fftshift(fft2(Is_imresize_maison))))); title('imresize maison')
colormap(jet)


