clear; close all; clc

img = imread('../img/barbara_awgn_noise.png');

%Filtre moyenneur rectangle uniforme
H = [1 1 1 ; 1 1 1; 1 1 1] / 9;
H = ones(3)/9; %équivalents
img_f = conv2(img, H);

figure, 
ll(1) = subplot(121); imagesc(img); title('Image initiale');
ll(2) = subplot(122); imagesc(img_f); title('Image filtrée (moyenneur)');
linkaxes(ll);
colormap(gray)
%Avec le moyenneur, on perd les textures

%% Gaussien

H = fspecial('gaussian', [7 7], 1.25); 
figure, surf(H); 
title('Filtre gaussien');

img_f = conv2(img, H);

figure, 
mm(1) = subplot(121); imagesc(img); title('Image initiale');
mm(2) = subplot(122); imagesc(img_f); title('Image filtrée (Gaussien)');
linkaxes(mm);
colormap(gray)
%Avec le Gaussien, un peu mieux mais pas des miracles

%Les deux filtrages échouent sur un bruit poivre et sel ('cameraman_sp_noise.png');

%% Filtrage médian

clear; close all; clc

img = imread('../img/cameraman_sp_noise.png');
[h,w,z] = size(img);

I_filtre = zeros(h,w,z);

v = 1; %demi taille du voisinage (2v+1)*(1v+1)
for i=1+v:h-v
    for j=1+v:w-v
        window = img(i-v:i+v, j-v:j+v, :);
        I_filtre(i,j) = median(window(:));
    end
end
figure
subplot 121
imagesc(img)
subplot 122
imagesc(I_filtre);
colormap(gray)


%% Comparaison au filtrage médian de Matlab (medfilt2)

figure,
subplot 121
imagesc(I_filtre)
title('Notre filtrage médian');
subplot 122
imagesc(medfilt2(img,[3 3]))
title('Filtrage Matlab medfilt2');

%Comparaison quantitative
diff = abs(double(I_filtre)-double(medfilt2(img,[3 3])));
figure, 
imagesc(diff)
colormap(gray)
title('Différence entre les filtrages');






